"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import { Helpers } from '~/cintap-ui/dist';
var BaseModel = function BaseModel(props) {
  var _this = this;

  _classCallCheck(this, BaseModel);

  Object.keys(props).forEach(function (field_name) {
    _this[field_name] = props[field_name];
  });
} // static signedGet = (api_path, data) => {
//   return axios.get(this.getApiUrl(api_path), {
//     headers: Helpers.signedHeaders
//   });
// }
// static unsignedPost = (api_path, data) => {
//   return axios.post(this.getApiUrl(api_path), (data || {}), { headers: Helpers.unsignedHeaders });
// }
// static signedPost = (api_path, data, headers) => {
//   if(!headers){
//     headers = {}
//   }
//   Object.keys(Helpers.signedHeaders).forEach((key) => {
//     headers[key] = Helpers.signedHeaders[key];
//   })
//   return axios.post(this.getApiUrl(api_path), (data || {}), { headers: headers });
// }
// static signedPut = (api_path, data, headers) => {
//   if(!headers){
//     headers = {}
//   }
//   Object.keys(Helpers.signedHeaders).forEach((key) => {
//     headers[key] = Helpers.signedHeaders[key];
//   })
//   return axios.put(this.getApiUrl(api_path), (data || {}), { headers: headers });
// }
;

exports.default = BaseModel;

_defineProperty(BaseModel, "setNamespace", function (namespace) {
  BaseModel.namespace = namespace;
});

_defineProperty(BaseModel, "setApiHost", function (apiHost) {
  BaseModel.apiHost = apiHost;
});

_defineProperty(BaseModel, "signedHeaders", function (accessToken) {
  return {
    headers: {
      Authorization: "Bearer ".concat(accessToken)
    }
  };
});

_defineProperty(BaseModel, "getLocalStorageKey", function (key) {
  return "".concat(BaseModel.namespace).concat(key);
});

_defineProperty(BaseModel, "getApiUrl", function (path, version) {
  var apiUrl = path;

  if (version === false) {
    if (BaseModel.apiHost.indexOf('/v1') !== -1) {
      apiUrl = "".concat(BaseModel.apiHost.replace('/v1', '')).concat(path);
    } else {
      apiUrl = "".concat(BaseModel.apiHost).concat(path);
    }
  } else {
    if (version === undefined || version === null) {
      if (BaseModel.apiHost.indexOf('/v1') !== -1) {
        apiUrl = "".concat(BaseModel.apiHost).concat(path);
      } else {
        apiUrl = "".concat(BaseModel.apiHost, "/v1").concat(path);
      }
    } else {
      if (version === '') {
        apiUrl = "".concat(BaseModel.apiHost).concat(path);
      } else {
        apiUrl = "".concat(BaseModel.apiHost, "/").concat(version).concat(path);
      }
    }
  }

  return apiUrl;
});

_defineProperty(BaseModel, "signedGet", function (api_path, data, accessToken, version) {
  return _axios.default.get(BaseModel.getApiUrl(api_path, version), BaseModel.signedHeaders(accessToken));
});

_defineProperty(BaseModel, "signedPost", function (api_path, data, accessToken, version) {
  return _axios.default.post(BaseModel.getApiUrl(api_path, version), data, BaseModel.signedHeaders(accessToken));
});

_defineProperty(BaseModel, "signedPut", function (api_path, data, accessToken, version) {
  return _axios.default.put(BaseModel.getApiUrl(api_path, version), data, BaseModel.signedHeaders(accessToken));
});

_defineProperty(BaseModel, "unsignedGet", function (api_path, data, version) {
  return _axios.default.get(BaseModel.getApiUrl(api_path, version), {
    headers: {},
    params: data || {}
  });
});

_defineProperty(BaseModel, "unsignedPost", function (api_path, data, version) {
  return _axios.default.post(BaseModel.getApiUrl(api_path, version), data || {});
});