"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _BaseModel2 = _interopRequireDefault(require("./BaseModel"));

var _Partner = _interopRequireDefault(require("./Partner"));

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var User = /*#__PURE__*/function (_BaseModel) {
  _inherits(User, _BaseModel);

  var _super = _createSuper(User);

  function User() {
    var _this;

    _classCallCheck(this, User);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "fullName", function () {
      return [_this.firstName, _this.middleName, _this.lastName].filter(function (item) {
        return item !== null && item !== undefined && item.toString().trim() !== '';
      }).join(' ');
    });

    return _this;
  }

  _createClass(User, null, [{
    key: "currentUser",
    get: function get() {
      var userDetails = localStorage.getItem(_BaseModel2.default.getLocalStorageKey('CurrentUser'));

      if (userDetails) {
        return new User(JSON.parse(userDetails));
      } else {
        return null;
      }
    },
    set: function set(userDetails) {
      localStorage.setItem(_BaseModel2.default.getLocalStorageKey('CurrentUser'), JSON.stringify(userDetails));
    }
  }]);

  return User;
}(_BaseModel2.default);

exports.default = User;

_defineProperty(User, "authenticateByEmailPassword", function (email, password) {
  var data = {
    "userName": email,
    "password": password
  };
  return User.unsignedPost("/auth/token", data, false);
});

_defineProperty(User, "authenticate2Fa", function (email, otp) {
  return User.unsignedPost("/2fa/".concat(email, "/").concat(otp), {});
});

_defineProperty(User, "afterAuthenticationByEmailPasswordSuccess", function (response) {
  if (response.data.statusCode === "000") {
    var _response$data = response.data,
        authToken = _response$data.authToken,
        result = _response$data.result;
    var userDetails = result;
    userDetails.authToken = authToken;
    User.currentUser = userDetails;
  }
});

_defineProperty(User, "authenticate", function (authToken) {
  return User.fetchUserByAuthToken(authToken);
});

_defineProperty(User, "afterTokenValidationSuccess", function (response, authToken) {
  var data = response.data;
  var userDetails = data[0];
  userDetails.authToken = authToken;
  userDetails.authenticationDate = (0, _moment.default)().format("YYYY-MM-DD HH:mm:ss");
  var partnerDetails = data[1];
  User.currentUser = userDetails;
  _Partner.default.currentPartner = partnerDetails;
});

_defineProperty(User, "isAuthenticatedWithInLast24Hours", function () {
  if (!User.currentUser) {
    return false;
  }

  ;
  return (0, _moment.default)().subtract(1, "day") < (0, _moment.default)(User.currentUser.authenticationDate);
});

_defineProperty(User, "signOut", function () {
  delete localStorage[_BaseModel2.default.getLocalStorageKey('CurrentUser')];
  delete localStorage[_BaseModel2.default.getLocalStorageKey('CurrentPartner')];
  delete localStorage[_BaseModel2.default.getLocalStorageKey('AssociatedPartners')];
});

_defineProperty(User, "fetchUserByAuthToken", function (authToken) {
  return User.unsignedGet("/auth/validate/".concat(authToken), {});
});