import React, { Fragment } from 'react';
import { Redirect } from 'react-router-dom';
import {
  Dropdown,
  DropdownToggle,
  DropdownMenu,
  DropdownItem
} from 'reactstrap';

export default class DropdownActions extends React.Component {
  constructor(props) {
    super(props);
  }

  render() {
    return <Dropdown className="text-center" direction="right" isOpen={this.state.dropdownOpen} toggle={this.toggle}>
      <DropdownToggle className="three-dots-btn" caret={false}>
        <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" className="bi bi-three-dots-vertical" viewBox="0 0 16 16">
          <path d="M9.5 13a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0zm0-5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0zm0-5a1.5 1.5 0 1 1-3 0 1.5 1.5 0 0 1 3 0z"/>
        </svg>
      </DropdownToggle>
      <DropdownMenu>
        {Object.keys(this.props.actions).map((actionKey) => {
          let redirectToActionKey = `redirectTo${actionKey}`;
          return <Fragment>
            <DropdownItem onClick={ () => this.setState({[redirectToActionKey]: true})}>
              {this.state[redirectToActionKey] && <Redirect
                exact
                to={this.props.actions[actionKey].redirectTo(this.props.object)}
              />}
              {this.props.actions[actionKey].actionName}
            </DropdownItem>
            <DropdownItem divider />
          </Fragment>
        })}
      </DropdownMenu>
    </Dropdown>
  }

  toggle = () => {
    this.setState({dropdownOpen: !this.state.dropdownOpen})
  }
}
