import React, { Fragment } from 'react';
import Helpers from '../utils/Helpers';
import Singular from './section_types/Singular';
import Tabular from './section_types/Tabular';

export default class Section extends React.Component {
  constructor(props) {
    super(props);
  }

  render() {
    return <Fragment>
      <div className={`section-heading ${this.props.className || ''}`}>
        <label>{this.props.sectionLabel}</label>
      </div>
      {this.props.sectionType === 'Singular' &&  <Singular section={this} />}
      {this.props.sectionType === 'Tabular' && <Tabular section={this} />}
    </Fragment>
  }

  getFieldValue = (fieldLabel) => {
    let fieldValue = this.props.sectionData[fieldLabel];
    if(typeof fieldValue === "function" ) {
      return fieldValue(this.props.sectionData);
    } else {
      return fieldValue;
    }
  }
}
