import React, { Fragment } from 'react';
import { withRouter } from 'react-router-dom';
import { Redirect } from 'react-router-dom';
import { Pagination, PaginationItem, PaginationLink } from 'reactstrap';

import AppRouter from '../utils/AppRouter';

import Helpers from '../utils/Helpers';


class SitePagination extends React.Component {
  constructor(props) {
    super(props);
    this.state = { pageNo: (this.props.pegable.pageNo + 1) }
  }

  componentDidMount() {
    this.setState({ redirectionNeeded: false })
  }

  createArrayOf = (n) => {
    let i = 1;
    let arr = [];
    for(; i <= n; i++) {
      arr.push(i);
    }
    return arr;
  }

  render() {
    return <Fragment>
      <Pagination aria-label="pagination" className={`${this.props.className || ''}`}>
        <PaginationItem className={`${this.state.pageNo === 1 ? 'disabled' : ''}`}>
          <PaginationLink style={{cursor: 'pointer'}} tag="button" aria-label=" " first onClick={this.firstPageClicked}/>
        </PaginationItem>
        <PaginationItem className={`${this.state.pageNo === 1 ? 'disabled' : ''}`}>
          <PaginationLink style={{cursor: 'pointer'}} tag="button" aria-label=" " previous onClick={this.previousPageClicked}/>
        </PaginationItem>
        {this.props.pegable.totalPages >= 5 && this.createArrayOf(5).map((pageNo) => {
          return <PaginationItem className={`${this.state.pageNo === pageNo ? 'active' : ''}`} key={Helpers.randomNumber}>
            <PaginationLink style={{cursor: 'pointer'}} tag="button" onClick={() => this.paginationLinkClicked(pageNo)}>
              {pageNo}
            </PaginationLink>
          </PaginationItem>
        })}
        {this.props.pegable.totalPages < 5 && this.createArrayOf(this.props.pegable.totalPages).map((pageNo) => {
          return <PaginationItem className={`${this.state.pageNo === pageNo ? 'active' : ''}`} key={Helpers.randomNumber}>
            <PaginationLink style={{cursor: 'pointer'}} tag="button" onClick={() => this.paginationLinkClicked(pageNo)}>
              {pageNo}
            </PaginationLink>
          </PaginationItem>
        })}
        <PaginationItem className={`${this.state.pageNo === this.props.pegable.totalPages ? 'disabled' : ''}`}>
          <PaginationLink style={{cursor: 'pointer'}} tag="button" aria-label=" " next onClick={this.nextPageClicked} />
        </PaginationItem>
        <PaginationItem className={`${this.state.pageNo === this.props.pegable.totalPages ? 'disabled' : ''}`}>
          <PaginationLink style={{cursor: 'pointer'}} tag="button" aria-label=" " last onClick={this.lastPageClicked}/>
        </PaginationItem>
      </Pagination>
      {this.state.redirectionNeeded && <Redirect
        exact
        to={{
          pathname: AppRouter.getPath('redirection'),
          state: {
            to: {
              pathname: this.props.paginationPath,
              search: `?page=${this.state.pageNo}`,
              exact: true
            }
          }
        }}
      />}
    </Fragment>
  }

  firstPageClicked = () => {
    if(this.state.pageNo !== 1) {
      this.paginationLinkClicked(1);
    }
  }

  previousPageClicked = () => {
    if(this.state.pageNo > 1) {
      this.paginationLinkClicked(this.state.pageNo - 1)
    }
  }

  paginationLinkClicked = (pageNo) => {
    if(this.state.pageNo !== pageNo) {
      this.setState({ pageNo: pageNo, redirectionNeeded: true });
    }
  }

  nextPageClicked = () => {
    if(this.state.pageNo < this.props.pegable.totalPages) {
      this.paginationLinkClicked(this.state.pageNo + 1)
    }
  }

  lastPageClicked = () => {
    if(this.props.pegable.totalPages !== this.state.pageNo) {
      this.paginationLinkClicked(this.props.pegable.totalPages)
    }
  }
}

export default withRouter(SitePagination);
