import React, { Fragment } from 'react';
import { Row, Col } from 'reactstrap';
import Helpers from '../../utils/Helpers';

export default class Singular extends React.Component {
  constructor(props) {
    super(props);
  }

  render() {
    let { section } = this.props;
    return <Fragment>
      {Helpers.inGroupOf(Object.keys(section.props.sectionData), section.props.cols).map((fieldLabels) => {
        return <Row key={Helpers.randomNumber} className="mt-2">
          {fieldLabels.map((fieldLabel) => {
            return <Col key={Helpers.randomNumber} sm={{ size: (12/section.props.cols) }}>
              <label className="fw-bold display-field-label">
                { fieldLabel }
              </label>
              <span className="display-field-value">{section.getFieldValue(fieldLabel)}</span>
            </Col>
          })}
        </Row>
      })}
    </Fragment>
  }
}
