import BaseModel from './BaseModel';
export default class Partner extends BaseModel {
  static set currentPartner(partnerDetails) {
    localStorage.setItem(BaseModel.getLocalStorageKey('CurrentPartner'), JSON.stringify(partnerDetails));
  }

  static get currentPartner() {
    let partnerDetails = localStorage.getItem(BaseModel.getLocalStorageKey('CurrentPartner'));
    if(partnerDetails) {
      return new Partner(JSON.parse(partnerDetails));
    } else {
      return null
    }
  }

  static fetchAssociatedPartners = (currentUser) => {
    return this.signedPost(`/v1/myassociatedtpandetp/${currentUser.partnerId}`, {}, currentUser.authToken)
  }

  static setAssociatedPartners = (associatedPartners) => {
    let finalResult = associatedPartners.reduce((result, associatedPartner) => {
      result[associatedPartner.partner] = associatedPartner
      return result;
    }, {});
    localStorage.setItem(BaseModel.getLocalStorageKey('AssociatedPartners'), JSON.stringify(finalResult));
  }

  static getAssociatedPartners = () => {
    return JSON.parse(localStorage.getItem(BaseModel.getLocalStorageKey('AssociatedPartners')) || "{}");
  }
}
