import React from 'react';
import { withRouter } from 'react-router-dom';

export default class AppRouter {
  constructor(path, path_name, pageComponent, pathFunction) {
    console.log(AppRouter.baseDir);
    this.path = `${AppRouter.baseDir || ''}${path}`;
    this.path_name = path_name;
    this.pageComponent = withRouter(pageComponent);
    this.pathFunction = pathFunction;
    AppRouter.routes[this.path_name] = this;
  }

  static setBaseDir = (baseDir) => {
    AppRouter.baseDir = baseDir;
  }

  static setPublicUrl = (publicUrl) => {
    AppRouter.publicUrl = publicUrl;
  }

  static getUrl(path_name, pathVariables) {
    let appRouter = AppRouter.getAppRouter(path_name);
    let path = AppRouter.getPath(path_name);
    if(appRouter.pathFunction) {
      return `${AppRouter.publicUrl}${path}`;
    } else {
      return path;
    }
  }

  static getPath(path_name, pathVariables) {
    let appRouter = AppRouter.getAppRouter(path_name);
    if(appRouter.pathFunction) {
      return `${AppRouter.baseDir || ''}${appRouter.pathFunction(pathVariables)}`;
    } else {
      return AppRouter.getAppRouter(path_name).path;
    }
  }

  static getAppRouter(path_name) {
    return AppRouter.routes[path_name]
  }

  page = (app) => {
    return React.createElement(
      this.pageComponent,
      {app: app},
      []
    )
  }
}
AppRouter.routes = {}
