import moment from 'moment';

export default class Helpers {

  static get randomNumber() {
    return parseInt(Math.random() * 1000000000)
  }

  static inGroupOf = (arr, chunk_size) => {
    let index = 0;
    let arrayLength = arr.length;
    let tempArray = [];

    for (index = 0; index < arrayLength; index += chunk_size) {
      let myChunk = arr.slice(index, index+chunk_size);
      // Do something if you want with the group
      tempArray.push(myChunk);
    }
    return tempArray;
  }

  static formatDate = (date_str, format) => {
    return moment(date_str).format(format);
  }


  static toTitleCase = (str) => {
    return str.replace(
      /\w\S*/g,
      function(txt) {
        return txt.charAt(0).toUpperCase() + txt.substr(1).toLowerCase();
      }
    );
  }
}
